#include <stdlib.h>
#include <stdio.h>
#include "secure_malloc.h"

int main(int argc, char** argv) {
   argv++; --argc;
   unsigned int nof_blocks = argc;
   for (unsigned int i = 0; i < nof_blocks; ++i) {
      size_t nbytes = atoi(*argv++); --argc;
      if (nbytes <= 0) exit(1);
      void* p = secure_malloc(nbytes);
      if (!p) {
	 perror("secure_malloc"); exit(1);
      }
      for (char* cp = p; cp < (char*) p + nbytes; ++cp) {
	 *cp = 0xff;
      }
      printf("%zd bytes allocated at %p\n", nbytes, p);
   }
   char* p; size_t nbytes;
   while (printf("address + nbytes: "), scanf("%p %zd", &p, &nbytes) == 2) {
      printf("p = %p, nbytes = %zd\n", p, nbytes);
      unsigned int count = 0;
      while (nbytes > 0) {
	 unsigned char ch = *p++; --nbytes;
	 if (count > 0 && count % 20 == 0) putchar('\n');
	 printf(" %02x", ch);
	 ++count;
      }
      putchar('\n');
   }
}
